-- Our new TOTAL chance
local MY_CHANCE = 0.1

------------------------------------------
-- Do not change anything below
------------------------------------------

local GAME_CHANCE = 0.2 -- The original code's chance

-- If we want 100% then make it 100%
-- (without this it will be 20% and then 80% - they both can fail)
MY_CHANCE = MY_CHANCE == 1 and 2 or MY_CHANCE

-- The original code will check 20% chance
MY_CHANCE = MY_CHANCE - GAME_CHANCE -- Our chance

-- Save the original function
local origfunc = AmmoClip._pickup

-- Override the original function
function AmmoClip:_pickup(unit)

	-- Get ties amount
	local cable_ties = managers.player:has_special_equipment('cable_tie')
	
	-- If cable_ties is not nil then get cable_ties.amount
	cable_ties = cable_ties and cable_ties.amount or nil

	-- Run the original function
	local val_to_return = origfunc(self, unit)
	
	-- Get ties amount again
	local cable_ties_new = managers.player:has_special_equipment('cable_tie')
	cable_ties_new = cable_ties_new and cable_ties_new.amount or nil
	
	-- 'amount' might not exist and give us nil
	if val_to_return and cable_ties and cable_ties_new then
	
		-- Our total chance is higher then the GAME_CHANCE
		if MY_CHANCE >= 0 and cable_ties_new == cable_ties then
			if math.random() <= MY_CHANCE then
				managers.player:add_cable_ties(1)
			end
			
			-- Our chance is zero, but the original chance passed. Remove the tie
		elseif MY_CHANCE <= (-1)*GAME_CHANCE and cable_ties_new ~= cable_ties then
			managers.player:add_cable_ties(-1)
			
			-- If we want total chance between 0 and GAME_CHANCE, we must compensate the original chance
			--- like if we want 10% and GAME_CHANCE = 20% then in 50% of the cases we remove the tie
		elseif MY_CHANCE < 0 and cable_ties_new ~= cable_ties then
			if math.random() <= (-1)*MY_CHANCE/GAME_CHANCE then
				managers.player:add_cable_ties(-1)
			end
		end
	end
	
	return val_to_return
end